var Overlay = (function ($) { 
    var myOverlay = {};
	
	function overlayController () {
		
		this.createOverley = function (flag) {
			if (!flag) return;
			
			$("body > #overlay").remove();
			//if($("#overlay").length) { alert('YES!'); }
			var docHeight = $(document).height();
			var overlay = '';
			overlay += '<div id="overlay"></div>';
			
			$(overlay)
				.appendTo("body")
				.height(docHeight)
				.css({
				'opacity': 0.4,
				'position': 'absolute',
				'top': 0,
				'left': 0,
				'background-color': 'black',
				'width': '100%',
				'z-index': 5000
			});
			
			overlay = '';
		}

		this.removeOverlay = function (flag) { if (!flag) $("body > #overlay").remove(); }

	}
	
	myOverlay.createOverley = function (flag) { 
		var mycreateOverley = new overlayController();
		mycreateOverley.createOverley(flag);
	}

	myOverlay.removeOverlay = function (flag) { 
		var myremoveOverley = new overlayController();
		myremoveOverley.removeOverlay(flag);
	}
	
	return myOverlay; 
}(jQuery)); // End Overlay

var PopupOverlay = (function ($) { 
    var myPopupOverlay = {};
	
	function popupOverlayController () {
		
		removePopup = function (flag) {
			if (!flag) {
				$("body > #popup").remove();
				Overlay.removeOverlay(false);
			}
		}
		
		this.removePopupExternal = function (flag) {
			if (!flag) {
				$("body > #popup").remove();
				Overlay.removeOverlay(false);
			}
		}
		
		this.clickButton = function () {
			console.log('myController.clickButton() START');
			$('body').on('click', '#buttonOK', function(){ removePopup(); });
		}
		
		this.createPopup = function (flag,text) {
			if (!flag) return;
			
			$("body > #popup").remove();
			var popupOK = '';
			popupOK += '<div id="popup" class="popupOverlay color666">';
			popupOK += '<p align="center">' + text + '</p>';
			popupOK += '<p align="center"><input type="button" name="buttonOK" id="buttonOK" value="OK" class="buttonGreen" /></p>';
			popupOK += '</div>';
			
			var docWidth = (parseInt($(document).width())/2 - 150) + 'px';
			var docHeight = (parseInt($(document).height())/2 - 75) + 'px';
			
			$(popupOK)
				.appendTo("body")
				.css({
				'opacity': 1.0,
				'position': 'absolute',
				'top': docHeight,
				'left': docWidth,
				'background-color': 'white',
				'z-index': 5100
			});
				
			popupOK = '';
		}

	}
	
	myPopupOverlay.createPopup = function (flag,text) { 
		var myCreatePopup = new popupOverlayController();
		myCreatePopup.createPopup(flag,text);
		myCreatePopup.clickButton();
	}

	myPopupOverlay.removePopupExternal = function (flag) { 
		var myRemovePopupExternal = new popupOverlayController();
		myRemovePopupExternal.removePopupExternal(flag);
		myRemovePopupExternal.clickButton();
	}
	
	return myPopupOverlay; 
}(jQuery)); // End PopupOverlay

var PopupFormOverlay = (function ($) { 
    var myPopupFormOverlay = {};
	
	myPopupFormOverlay.dataForm = '###';
	
	function popupFormOverlayController () {
		
		function funAjax (dataForm,command) {
			dataForm += 'RedirectAddresses=' + myPopupFormOverlay.dataForm;
			//console.log(dataForm);
			$.ajax({
				type: "POST",
				url: "mailbox.wssp",
				data: dataForm,
				success: function(data){
					//console.log(data );
					var indexA = data.indexOf('<span class="successText">');
					if (indexA > -1) {
						indexA = indexA + 26;
						var dataB = data.substring(indexA);
						var indexB = dataB.indexOf('</');
						switch (command) {
						   case 'Copy':
							  	Overlay.createOverley(true);
								PopupOverlay.createPopup(true,dataB.substring(0,indexB));
							  	break
						   case 'Delete': break
						   case 'Read': break
						   case 'Redirect':
							  	Overlay.createOverley(true);
								PopupOverlay.createPopup(true,dataB.substring(0,indexB));
							  	break
						   default: break
						}
						/*
						if (flagPopup) {
							Overlay.createOverley(true);
							PopupOverlay.createPopup(true,dataB.substring(0,indexB));
						}
						*/
					}
				}
				
			});
 
			$("#pane-center").load(	
							'mailbox.wssp',
							function(data) {
								Mailboxes.outputMethod(startParam);
							}
			 );
		}
		
		removePopupForm = function (flag,dataForm,command) {
			if (!flag) {
				myPopupFormOverlay.dataForm = $('#RedirectAddresses').val();
				//dataForm += myPopupFormOverlay.dataForm;
				$("body > #popup").remove();
				Overlay.removeOverlay(false);
				funAjax(dataForm,command);
			}
		}
		
		this.removePopupFormExternal = function (flag) {
			if (!flag) {
				$("body > #popup").remove();
				Overlay.removeOverlay(false);
			}
		}
		
		this.clickButton = function (dataForm,command) {
			console.log('myController.clickButton() START');
			$('body').on('click', '#buttonOK', function(){ removePopupForm(false,dataForm,command); });
		}
		
		this.createPopupForm = function (flag,callback) {
			if (!flag) return;
			
			$("body > #popup").remove();
			var popupWithTextarea = '';
			popupWithTextarea += '<div id="popup" class="popupOverlay color666">';
			popupWithTextarea += '<p align="center"><textarea name="RedirectAddresses" id="RedirectAddresses" rows="3" cols="25"></textarea></p>';
			popupWithTextarea += '<p align="center">';
			popupWithTextarea += '<input type="button" name="buttonOK" id="buttonOK" value="OK" class="buttonGreen" />';
			popupWithTextarea += '&nbsp;&nbsp;&nbsp;&nbsp;';
			popupWithTextarea += '<input type="button" name="buttonCancel" id="buttonCancel" value="Cancel" class="buttonWhite" />';
			popupWithTextarea += '</p>';
			popupWithTextarea += '</div>';
			
			var docWidth = (parseInt($(document).width())/2 - 150) + 'px';
			var docHeight = (parseInt($(document).height())/2 - 75) + 'px';
			
			$(popupWithTextarea)
				.appendTo("body")
				.css({
				'opacity': 1.0,
				'position': 'absolute',
				'top': docHeight,
				'left': docWidth,
				'background-color': 'white',
				'z-index': 5100
			});
				
			popupWithTextarea = '';
		}

	}
	
	myPopupFormOverlay.createPopupForm = function (flag,dataForm) { 
		var myCreatePopupForm = new popupFormOverlayController();
		myCreatePopupForm.createPopupForm(flag);
		myCreatePopupForm.clickButton(dataForm,'Redirect');
	}

	myPopupFormOverlay.removePopupFormExternal = function (flag) { 
		var myRemovePopupFormExternal = new popupFormOverlayController();
		myRemovePopupFormExternal.removePopupFormExternal(flag);
		myRemovePopupFormExternal.clickButton();
	}
	
	return myPopupFormOverlay; 
}(jQuery)); // End PopupFormOverlay
